<template>
  <div id="app">
    <div id="title-bar">
      <div id="title-bar-btns">
        <button @click="minimizeWindow">-</button>
        <button @click="closeWindow">x</button>
      </div>
    </div>
    <div id="container">
      <section id="room" v-if="visibleRoom">
        Room name:
        <input type="text" v-model="curRoomName" autofocus />
        <br />
        <br />
        <button v-on:click="setRoomName">Enter</button>
        <br />
      </section>
      <h1 v-if="visibleRoom == false">Room: {{ roomName }}</h1>
      <br />
      <!-- <br /> -->
      <!-- <video
        id="Helloo"
        class="web-cam"
        :width="videoWidth"
        :height="videoHeight"
        :src-object.prop.camel="localView"
        autoplay
        muted
      ></video> -->
      <video
        class="web-cam"
        :width="videoWidth"
        :height="videoHeight"
        :src-object.prop.camel="remoteView"
        autoplay
      ></video>
      <!-- <br /> -->
      <!-- <br /> -->
      <!-- <button id="audio-mute" v-on:click="audioMute">Audio mute</button>
      <button id="audio-unmute" style="display: none">Audio unmute</button>
      <button id="video-mute">Video mute</button> -->
      <br />
      <br />
      <!-- <button @click="createNewWindow">New Window</button> -->
      <button id="video-unmute" onclick="videoMute()" style="display: none">
        Video unmute
      </button>
      <!-- <button id="shareScreen" v-on:click="minimizeWindow">Minimize</button> -->
      <button
        id="stopShareScreen"
        onclick="stopShareScreen()"
        style="display: none"
      >
        Stop Share screen
      </button>
    </div>
  </div>
</template>

<script>
import { BrowserWindow } from 'electron';
import { Console } from 'console';
export default {
  name: 'nine',
  data() {
    return {
      videoWidth: 250,
      videoHeight: 250,
      curRoomName: '',
      roomName: '',
      visibleRoom: true,
      localView: null,
      remoteView: null,
      socket: null,
      connection: null,
      localStream: null,
      existingTracks: [],
      configuration: {
        iceServers: [
          {
            urls: 'turn:turnserver.appearin.net:443?transport=udp',
            credential: 'xOXvyhbA+OOOvON+yjJlFrad2y0=',
            username: '196a444c-c2c6-49f1-973c-c0ff3ad497e6:1584683669'
          },
          {
            urls: 'stun:stun1.l.google.com:19302'
          },
          {
            urls: 'stun:stun2.l.google.com:19302'
          },
          {
            urls: 'stun:stun3.l.google.com:19302'
          }
          // ,
          // {
          //   urls: "turn:" + turnServerIPAddress + ":" + turnServerPort,
          //   username: turnServerUserName,
          //   credential: turnServerPassword
          // }
        ]
      }
    };
  },
  methods: {
    minimizeWindow() {
      let ipcRenderer = window.require('electron').ipcRenderer;
      ipcRenderer.send('minimize-window');
    },
    closeWindow() {
      let ipcRenderer = window.require('electron').ipcRenderer;
      ipcRenderer.send('close-window');
    },
    createRTCPeerConnection() {
      return new Promise((resolve, reject) => {
        try {
          this.connection = new RTCPeerConnection(this.configuration);
          console.log(this.socket);
          for (const track of this.localStream.getTracks()) {
            this.existingTracks.push(
              this.connection.addTrack(track, this.localStream)
            );
          }

          this.connection.ontrack = (event) => {
            console.log('on track');
            this.remoteView = event.streams[0];
          };
          this.connection.onicecandidate = (event) => {
            if (event.candidate) {
              // console.log(event.candidate);
              // console.log("on ice candidate");
              this.socket.emit('update', {
                iceCandidate: event.candidate,
                roomName: this.roomName
              });
            }
          };

          this.connection.onnegotiationneeded = (e) => {
            if (this.connection.signalingState != 'stable') return;
          };

          resolve(true);
        } catch (e) {
          reject(e);
        }
      });
    },

    async handleOffer(offer) {
      console.log('offer received');
      this.connection.setRemoteDescription(new RTCSessionDescription(offer));
    },

    async createAndSendAnswer() {
      try {
        const answer = await this.connection.createAnswer();
        this.socket.emit('update', {
          connectionHandShake: answer,
          roomName: this.roomName
        });
        this.connection.setLocalDescription(answer);
      } catch (e) {
        console.error(e);
      }
    },
    async handleAnswer(answer) {
      console.log('answer received');
      this.connection.setRemoteDescription(new RTCSessionDescription(answer));
    },

    handleCandidate(candidate) {
      console.log('handleCandidate', candidate);
      this.connection.addIceCandidate(new RTCIceCandidate(candidate));
    },

    webrtcCall() {
      this.localCameraView()
        .then(() => {
          return this.createRTCPeerConnection();
        })
        .then(() => {
          this.createAndSendOffer();
        });

      this.socket.on('update', (data) => {
        if (data.connectionHandShake) {
          const handsh = data.connectionHandShake;
          if (handsh.type === 'offer') {
            let ipcRenderer = window.require('electron').ipcRenderer;
            // ipcRenderer.send('key-press');
            // ipcRenderer.send('move-video');
            window.setInterval(function() {
              ipcRenderer.send('key-press');
            }, 5000);
            // let ipcRenderer = window.require('electron').ipcRenderer;

            this.handleOffer(handsh);
            this.createAndSendAnswer();
          }
          if (handsh.type === 'answer') {
            this.handleAnswer(handsh);
          }
        } else if (data.iceCandidate) {
          this.handleCandidate(data.iceCandidate);
        }
      });
    },
    async createAndSendOffer() {
      const oo = this.roomName;
      try {
        const offer = await this.connection.createOffer();
        this.socket.emit('update', { connectionHandShake: offer, oo });
        this.connection.setLocalDescription(offer);
      } catch (e) {
        console.error(e);
      }
    },

    async localCameraView() {
      try {
        const stream = await navigator.mediaDevices.getUserMedia({
          video: true,
          audio: true
        });
        window.stream = stream;
        this.localStream = stream;
        // this.localView = stream;
        // const anotherVideo = document.createElement("video");
        // anotherVideo.srcObject = stream;
        // this.hasLocalStream = true;
        return stream;
      } catch (e) {
        console.log(e);
      }
    },
    socketCall() {
      this.socket = io('https://peaceful-retreat-41212.herokuapp.com/');
      const abc = this;
      this.socket.on('connect', () => {
        console.log('Connected to the socket');
        this.socket.emit('newUser', {
          roomName: this.roomName,
          userId: this.socket.id
        });
        // abc.createAndSendAnswer();
      });
    },

    setRoomName() {
      this.roomName = this.curRoomName;
      this.curRoomName = '';
      this.visibleRoom = false;
      this.socketCall();
      this.webrtcCall();
    },

    audioMute() {
      let audioTracks = this.localStream.getAudioTracks();
      for (let i = 0; i < audioTracks.length; ++i)
        audioTracks[i].enabled = !audioTracks[i].enabled;
      if (audioTracks[0].enabled) {
        document.getElementById('audio-mute').style.display = 'inline-block';
        document.getElementById('audio-unmute').style.display = 'none';
      } else {
        document.getElementById('audio-mute').style.display = 'none';
        document.getElementById('audio-unmute').style.display = 'inline-block';
      }
      console.log(audioTracks);
    }
  }
};
</script>

<style>
* {
  box-sizing: border-box;
}

html {
  font-family: 'Jost', sans-serif;
}

body {
  margin: 0;
}

header {
  box-shadow: 0 2px 30px rgba(0, 0, 0, 0.26);
  margin: 3rem;
  border-radius: 10px;
  padding: 1rem;
  background-color: #1b995e;
  color: white;
  text-align: center;
}

video {
  box-shadow: 1 2px 10px rgba(0, 0, 0, 0.26);
  border-radius: 10px;
  /* padding: 1rem; */
}

.web-cam {
  border-radius: 50%;
  object-fit: cover;
  /* width: 150px;
  height: 150px; */
  /* border-radius: 325px;
  -webkit-mask-image: -webkit-radial-gradient(circle, white 100%, black 100%); */
}

#container {
  box-shadow: 1 2px 8px rgba(0, 0, 0, 0.26);
  margin: 1rem;
  border-radius: 10px;
  padding: 1rem;
  text-align: center;
}

#container h2 {
  font-size: 2rem;
  border-bottom: 4px solid #ccc;
  color: #1b995e;
  margin: 0 0 1rem 0;
}

#container p,
li {
  font-size: 1.25rem;
  font-weight: bold;
  background-color: #8ddba4;
  padding: 0.5rem;
  color: #1f1f1f;
  border-radius: 25px;
}

#container input {
  font: inherit;
  border: 1px solid #ccc;
}
#container video {
  transform: rotateY(180deg);
  -webkit-transform: rotateY(180deg); /* Safari and Chrome */
  -moz-transform: rotateY(180deg); /* Firefox */
}
#container input:focus {
  outline: none;
  border-color: #1b995e;
  background-color: #d7fdeb;
}

#container button {
  font: inherit;
  cursor: pointer;
  border: 1px solid #ff0077;
  background-color: #ff0077;
  color: white;
  padding: 0.05rem 1rem;
  box-shadow: 1px 1px 2px rgba(0, 0, 0, 0.26);
}

#container button:hover,
button:active {
  background-color: #ec3169;
  border-color: #ec3169;
  box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.26);
}

#title-bar {
  -webkit-app-region: drag;
  height: 30px;
  /* border-bottom: 1px solid #ec3169; */
  box-shadow: 1px 1px 2px rgba(0, 0, 0, 0.26);

  /* background-color: #ff0077; */
  padding: none;
  margin: 0px;
}

#title-bar-btns {
  -webkit-app-region: no-drag;
  position: fixed;
  top: 2px;
  right: 5px;
}

#title-bar-btns button {
  color: white;
  background-color: #ff0077;
  border: 0px;
  cursor: pointer;
  padding: 0.05rem 1rem;
}
#title-bar-btns button:active,
button:hover {
  background-color: #ec3169;
  border-color: #ec3169;
  box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.26);
}
</style>
